<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>sequelize-cheatsheet</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="sequelize-cheatsheet">Sequelize Cheatsheet</h1>
    <h2 id="command-line">Command Line</h2>
    <p>
      Sequelize provides utilities for generating migrations, models, and seed
      files. They are exposed through the <code>sequelize-cli</code> command.
    </p>
    <h3 id="init-project">Init Project</h3>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb1-1" title="1">$ <span class="ex">npx</span> sequelize-cli init</a></code></pre>
    </div>
    <p>
      You must create a database user, and update the
      <code>config/config.json</code> file to match your database settings to
      complete the initialization process.
    </p>
    <h3 id="create-database">Create Database</h3>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1">$ <span class="ex">npx</span> sequelize-cli db:create</a></code></pre>
    </div>
    <h3 id="generate-a-model-and-its-migration">
      Generate a model and its migration
    </h3>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb3-1" title="1">$ <span class="ex">npx</span> sequelize-cli model:generate --name <span class="op">&lt;</span>ModelName<span class="op">&gt;</span> --attributes <span class="op">&lt;</span>column1<span class="op">&gt;</span>:<span class="op">&lt;</span>type<span class="op">&gt;</span>,<span class="op">&lt;</span>column2<span class="op">&gt;</span>:<span class="op">&lt;</span>type<span class="op">&gt;</span>,...</a></code></pre>
    </div>
    <h3 id="run-pending-migrations">Run pending migrations</h3>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb4-1" title="1">$ <span class="ex">npx</span> sequelize-cli db:migrate</a></code></pre>
    </div>
    <h3 id="rollback-one-migration">Rollback one migration</h3>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb5-1" title="1">$ <span class="ex">npx</span> sequelize-cli db:migrate:undo</a></code></pre>
    </div>
    <h3 id="rollback-all-migrations">Rollback all migrations</h3>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb6-1" title="1">$ <span class="ex">npx</span> sequelize-cli db:migrate:undo:all</a></code></pre>
    </div>
    <h3 id="generate-a-new-seed-file">Generate a new seed file</h3>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb7-1" title="1">$ <span class="ex">npx</span> sequelize-cli seed:generate --name <span class="op">&lt;</span>descriptiveName<span class="op">&gt;</span></a></code></pre>
    </div>
    <h3 id="run-all-pending-seeds">Run all pending seeds</h3>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb8-1" title="1">$ <span class="ex">npx</span> sequelize-cli db:seed:all</a></code></pre>
    </div>
    <h3 id="rollback-one-seed">Rollback one seed</h3>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb9-1" title="1">$ <span class="ex">npx</span> sequelize-cli db:seed:undo</a></code></pre>
    </div>
    <h3 id="rollback-all-seeds">Rollback all seeds</h3>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode bash"
      ><code class="sourceCode bash"><a class="sourceLine" id="cb10-1" title="1">$ <span class="ex">npx</span> sequelize-cli db:seed:undo:all</a></code></pre>
    </div>
    <h2 id="migrations">Migrations</h2>
    <h3 id="column-attribute-keywords">Column Attribute Keywords</h3>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="op">&lt;</span>columnName<span class="op">&gt;:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb11-2" title="2">    <span class="dt">type</span><span class="op">:</span> <span class="va">Sequelize</span>.<span class="op">&lt;</span>type<span class="op">&gt;,</span></a>
<a class="sourceLine" id="cb11-3" title="3">    <span class="dt">allowNull</span><span class="op">:</span> <span class="op">&lt;</span><span class="kw">true</span><span class="op">|</span><span class="kw">false</span><span class="op">&gt;,</span></a>
<a class="sourceLine" id="cb11-4" title="4">    <span class="dt">unique</span><span class="op">:</span> <span class="op">&lt;</span><span class="kw">true</span><span class="op">|</span><span class="kw">false</span><span class="op">&gt;,</span></a>
<a class="sourceLine" id="cb11-5" title="5">    <span class="dt">references</span><span class="op">:</span> <span class="op">{</span> <span class="dt">model</span><span class="op">:</span> <span class="op">&lt;</span>TableName<span class="op">&gt;</span> <span class="op">},</span> <span class="co">// This is the plural table name that the column references.</span></a>
<a class="sourceLine" id="cb11-6" title="6"><span class="op">}</span></a></code></pre>
    </div>
    <h2 id="model-associations">Model Associations</h2>
    <h3 id="one-to-one-between-student-and-scholarship">
      One to One between Student and Scholarship
    </h3>
    <p><code>student.js</code></p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1">    <span class="va">Student</span>.<span class="at">hasOne</span>(<span class="va">models</span>.<span class="at">Scholarship</span><span class="op">,</span> <span class="op">{</span> <span class="dt">foreignKey</span><span class="op">:</span> <span class="st">&#39;studentId&#39;</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p><code>scholarship.js</code></p>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1">    <span class="va">Scholarship</span>.<span class="at">belongsTo</span>(<span class="va">models</span>.<span class="at">Student</span><span class="op">,</span> <span class="op">{</span> <span class="dt">foreignKey</span><span class="op">:</span> <span class="st">&#39;studentId&#39;</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h3 id="one-to-many-between-student-and-class">
      One to Many between Student and Class
    </h3>
    <p><code>student.js</code></p>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1">    <span class="va">Student</span>.<span class="at">belongsTo</span>(<span class="va">models</span>.<span class="at">Class</span><span class="op">,</span> <span class="op">{</span> <span class="dt">foreignKey</span><span class="op">:</span> <span class="st">&#39;classId&#39;</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p><code>class.js</code></p>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1">    <span class="va">Class</span>.<span class="at">hasMany</span>(<span class="va">models</span>.<span class="at">Student</span><span class="op">,</span> <span class="op">{</span> <span class="dt">foreignKey</span><span class="op">:</span> <span class="st">&#39;classId&#39;</span> <span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h3
      id="many-to-many-between-student-and-lesson-through-studentlessons-table"
    >
      Many to Many between Student and Lesson through StudentLessons table
    </h3>
    <p><code>student.js</code></p>
    <div class="sourceCode" id="cb16">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb16-1" title="1">    <span class="kw">const</span> columnMapping <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb16-2" title="2">        <span class="dt">through</span><span class="op">:</span> <span class="st">&#39;StudentLesson&#39;</span><span class="op">,</span> <span class="co">// This is the model name referencing the join table.</span></a>
<a class="sourceLine" id="cb16-3" title="3">        <span class="dt">otherKey</span><span class="op">:</span> <span class="st">&#39;lessonId&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb16-4" title="4">        <span class="dt">foreignKey</span><span class="op">:</span> <span class="st">&#39;studentId&#39;</span></a>
<a class="sourceLine" id="cb16-5" title="5">    <span class="op">}</span></a>
<a class="sourceLine" id="cb16-6" title="6"></a>
<a class="sourceLine" id="cb16-7" title="7">    <span class="va">Student</span>.<span class="at">belongsToMany</span>(<span class="va">models</span>.<span class="at">Lesson</span><span class="op">,</span> columnMapping)<span class="op">;</span></a></code></pre>
    </div>
    <p><code>lesson.js</code></p>
    <div class="sourceCode" id="cb17">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb17-1" title="1">    <span class="kw">const</span> columnMapping <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb17-2" title="2">        <span class="dt">through</span><span class="op">:</span> <span class="st">&#39;StudentLesson&#39;</span><span class="op">,</span> <span class="co">// This is the model name referencing the join table.</span></a>
<a class="sourceLine" id="cb17-3" title="3">        <span class="dt">otherKey</span><span class="op">:</span> <span class="st">&#39;studentId&#39;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb17-4" title="4">        <span class="dt">foreignKey</span><span class="op">:</span> <span class="st">&#39;lessonId&#39;</span></a>
<a class="sourceLine" id="cb17-5" title="5">    <span class="op">}</span></a>
<a class="sourceLine" id="cb17-6" title="6"></a>
<a class="sourceLine" id="cb17-7" title="7">    <span class="va">Lesson</span>.<span class="at">belongsToMany</span>(<span class="va">models</span>.<span class="at">Student</span><span class="op">,</span> columnMapping)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="query-format">Query Format</h2>
    <h3 id="findone">findOne</h3>
    <div class="sourceCode" id="cb18">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb18-1" title="1"><span class="op">&lt;</span>Model<span class="op">&gt;</span>.<span class="at">findOne</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb18-2" title="2">  <span class="dt">where</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb18-3" title="3">      <span class="op">&lt;</span>column<span class="op">&gt;:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb18-4" title="4">          [<span class="va">Op</span>.<span class="op">&lt;</span>operator<span class="op">&gt;</span>]<span class="op">:</span> <span class="op">&lt;</span>value<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb18-5" title="5">      <span class="op">}</span></a>
<a class="sourceLine" id="cb18-6" title="6">  <span class="op">},</span></a>
<a class="sourceLine" id="cb18-7" title="7"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h3 id="findall">findAll</h3>
    <div class="sourceCode" id="cb19">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb19-1" title="1"><span class="op">&lt;</span>Model<span class="op">&gt;</span>.<span class="at">findAll</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb19-2" title="2">  <span class="dt">where</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb19-3" title="3">    <span class="op">&lt;</span>column<span class="op">&gt;:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb19-4" title="4">        [<span class="va">Op</span>.<span class="op">&lt;</span>operator<span class="op">&gt;</span>]<span class="op">:</span> <span class="op">&lt;</span>value<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb19-5" title="5">    <span class="op">}</span></a>
<a class="sourceLine" id="cb19-6" title="6">  <span class="op">},</span></a>
<a class="sourceLine" id="cb19-7" title="7">  <span class="dt">include</span><span class="op">:</span> <span class="op">&lt;</span>include_specifier<span class="op">&gt;,</span></a>
<a class="sourceLine" id="cb19-8" title="8">  <span class="dt">offset</span><span class="op">:</span> <span class="dv">10</span><span class="op">,</span></a>
<a class="sourceLine" id="cb19-9" title="9">  <span class="dt">limit</span><span class="op">:</span> <span class="dv">2</span></a>
<a class="sourceLine" id="cb19-10" title="10"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h3 id="findbypk">findByPk</h3>
    <div class="sourceCode" id="cb20">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb20-1" title="1"><span class="op">&lt;</span>Model<span class="op">&gt;</span>.<span class="at">findByPk</span>(<span class="op">&lt;</span>primary_key<span class="op">&gt;,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb20-2" title="2">    <span class="dt">include</span><span class="op">:</span> <span class="op">&lt;</span>include_specifier<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb20-3" title="3"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h3 id="common-where-operators">Common Where Operators</h3>
    <div class="sourceCode" id="cb21">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb21-1" title="1"><span class="kw">const</span> Op <span class="op">=</span> <span class="va">Sequelize</span>.<span class="at">Op</span></a>
<a class="sourceLine" id="cb21-2" title="2"></a>
<a class="sourceLine" id="cb21-3" title="3">[<span class="va">Op</span>.<span class="at">and</span>]<span class="op">:</span> [<span class="op">{</span><span class="dt">a</span><span class="op">:</span> <span class="dv">5</span><span class="op">},</span> <span class="op">{</span><span class="dt">b</span><span class="op">:</span> <span class="dv">6</span><span class="op">}</span>] <span class="co">// (a = 5) AND (b = 6)</span></a>
<a class="sourceLine" id="cb21-4" title="4">[<span class="va">Op</span>.<span class="at">or</span>]<span class="op">:</span> [<span class="op">{</span><span class="dt">a</span><span class="op">:</span> <span class="dv">5</span><span class="op">},</span> <span class="op">{</span><span class="dt">a</span><span class="op">:</span> <span class="dv">6</span><span class="op">}</span>]  <span class="co">// (a = 5 OR a = 6)</span></a>
<a class="sourceLine" id="cb21-5" title="5">[<span class="va">Op</span>.<span class="at">gt</span>]<span class="op">:</span> <span class="dv">6</span><span class="op">,</span>                <span class="co">// &gt; 6</span></a>
<a class="sourceLine" id="cb21-6" title="6">[<span class="va">Op</span>.<span class="at">gte</span>]<span class="op">:</span> <span class="dv">6</span><span class="op">,</span>               <span class="co">// &gt;= 6</span></a>
<a class="sourceLine" id="cb21-7" title="7">[<span class="va">Op</span>.<span class="at">lt</span>]<span class="op">:</span> <span class="dv">10</span><span class="op">,</span>               <span class="co">// &lt; 10</span></a>
<a class="sourceLine" id="cb21-8" title="8">[<span class="va">Op</span>.<span class="at">lte</span>]<span class="op">:</span> <span class="dv">10</span><span class="op">,</span>              <span class="co">// &lt;= 10</span></a>
<a class="sourceLine" id="cb21-9" title="9">[<span class="va">Op</span>.<span class="at">ne</span>]<span class="op">:</span> <span class="dv">20</span><span class="op">,</span>               <span class="co">// != 20</span></a>
<a class="sourceLine" id="cb21-10" title="10">[<span class="va">Op</span>.<span class="at">eq</span>]<span class="op">:</span> <span class="dv">3</span><span class="op">,</span>                <span class="co">// = 3</span></a>
<a class="sourceLine" id="cb21-11" title="11">[<span class="va">Op</span>.<span class="at">is</span>]<span class="op">:</span> <span class="kw">null</span>              <span class="co">// IS NULL</span></a>
<a class="sourceLine" id="cb21-12" title="12">[<span class="va">Op</span>.<span class="at">not</span>]<span class="op">:</span> <span class="kw">true</span><span class="op">,</span>            <span class="co">// IS NOT TRUE</span></a>
<a class="sourceLine" id="cb21-13" title="13">[<span class="va">Op</span>.<span class="at">between</span>]<span class="op">:</span> [<span class="dv">6</span><span class="op">,</span> <span class="dv">10</span>]<span class="op">,</span>     <span class="co">// BETWEEN 6 AND 10</span></a>
<a class="sourceLine" id="cb21-14" title="14">[<span class="va">Op</span>.<span class="at">notBetween</span>]<span class="op">:</span> [<span class="dv">11</span><span class="op">,</span> <span class="dv">15</span>]<span class="op">,</span> <span class="co">// NOT BETWEEN 11 AND 15</span></a>
<a class="sourceLine" id="cb21-15" title="15">[<span class="va">Op</span>.<span class="at">in</span>]<span class="op">:</span> [<span class="dv">1</span><span class="op">,</span> <span class="dv">2</span>]<span class="op">,</span>           <span class="co">// IN [1, 2]</span></a>
<a class="sourceLine" id="cb21-16" title="16">[<span class="va">Op</span>.<span class="at">notIn</span>]<span class="op">:</span> [<span class="dv">1</span><span class="op">,</span> <span class="dv">2</span>]<span class="op">,</span>        <span class="co">// NOT IN [1, 2]</span></a>
<a class="sourceLine" id="cb21-17" title="17">[<span class="va">Op</span>.<span class="at">like</span>]<span class="op">:</span> <span class="st">&#39;%hat&#39;</span><span class="op">,</span>         <span class="co">// LIKE &#39;%hat&#39;</span></a>
<a class="sourceLine" id="cb21-18" title="18">[<span class="va">Op</span>.<span class="at">notLike</span>]<span class="op">:</span> <span class="st">&#39;%hat&#39;</span>       <span class="co">// NOT LIKE &#39;%hat&#39;</span></a>
<a class="sourceLine" id="cb21-19" title="19">[<span class="va">Op</span>.<span class="at">iLike</span>]<span class="op">:</span> <span class="st">&#39;%hat&#39;</span>         <span class="co">// ILIKE &#39;%hat&#39; (case insensitive) (PG only)</span></a>
<a class="sourceLine" id="cb21-20" title="20">[<span class="va">Op</span>.<span class="at">notILike</span>]<span class="op">:</span> <span class="st">&#39;%hat&#39;</span>      <span class="co">// NOT ILIKE &#39;%hat&#39;  (PG only)</span></a>
<a class="sourceLine" id="cb21-21" title="21">[<span class="va">Op</span>.<span class="at">startsWith</span>]<span class="op">:</span> <span class="st">&#39;hat&#39;</span>     <span class="co">// LIKE &#39;hat%&#39;</span></a>
<a class="sourceLine" id="cb21-22" title="22">[<span class="va">Op</span>.<span class="at">endsWith</span>]<span class="op">:</span> <span class="st">&#39;hat&#39;</span>       <span class="co">// LIKE &#39;%hat&#39;</span></a>
<a class="sourceLine" id="cb21-23" title="23">[<span class="va">Op</span>.<span class="at">substring</span>]<span class="op">:</span> <span class="st">&#39;hat&#39;</span>      <span class="co">// LIKE &#39;%hat%&#39;</span></a>
<a class="sourceLine" id="cb21-24" title="24">[<span class="va">Op</span>.<span class="at">regexp</span>]<span class="op">:</span> <span class="st">&#39;^[h|a|t]&#39;</span>    <span class="co">// REGEXP/~ &#39;^[h|a|t]&#39; (MySQL/PG only)</span></a>
<a class="sourceLine" id="cb21-25" title="25">[<span class="va">Op</span>.<span class="at">notRegexp</span>]<span class="op">:</span> <span class="st">&#39;^[h|a|t]&#39;</span> <span class="co">// NOT REGEXP/!~ &#39;^[h|a|t]&#39; (MySQL/PG only)</span></a>
<a class="sourceLine" id="cb21-26" title="26">[<span class="va">Op</span>.<span class="at">iRegexp</span>]<span class="op">:</span> <span class="st">&#39;^[h|a|t]&#39;</span>    <span class="co">// ~* &#39;^[h|a|t]&#39; (PG only)</span></a>
<a class="sourceLine" id="cb21-27" title="27">[<span class="va">Op</span>.<span class="at">notIRegexp</span>]<span class="op">:</span> <span class="st">&#39;^[h|a|t]&#39;</span> <span class="co">// !~* &#39;^[h|a|t]&#39; (PG only)</span></a>
<a class="sourceLine" id="cb21-28" title="28">[<span class="va">Op</span>.<span class="at">like</span>]<span class="op">:</span> <span class="op">{</span> [<span class="va">Op</span>.<span class="at">any</span>]<span class="op">:</span> [<span class="st">&#39;cat&#39;</span><span class="op">,</span> <span class="st">&#39;hat&#39;</span>]<span class="op">}</span></a></code></pre>
    </div>
  </body>
</html>
